/*
ID: espr1t
TASK: SuperMario
KEYWORDS: Medium, DP, Inner Cycle Optimization
*/

#include <cstdio>
#include <queue>

using namespace std;
FILE* in = stdin; FILE* out = stdout;

const int MAX = 10000004;

int n, k;
long long a[MAX];

int main(void) {
//    in = fopen("SuperMario.in", "rt");

    int F, A, B, M;
    fscanf(in, "%d %d", &n, &k);
    fscanf(in, "%d %d %d %d", &F, &A, &B, &M);
    a[1] = F;
    for (int i = 2; i <= n; i++)
        a[i] = (a[i - 1] * A + B) % M;

    priority_queue < pair <long long, int> > q;
    q.push(make_pair(0, n + 1));
    for (int i = n; i >= 0; i--) {
        while (!q.empty() && i + k < q.top().second)
            q.pop();
        q.push(make_pair(-a[i] + q.top().first, i));
    }
    fprintf(out, "%lld\n", -q.top().first);
    return 0;
}
